(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('mw-form-builder', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (factory((global['mw-form-builder'] = {}),global.ng.core,global.ng.forms,global.ng.common));
}(this, (function (exports,core,ng,common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstract-form-field/abstract-form-field.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var AbstractFormFieldComponent = /** @class */ (function () {
        function AbstractFormFieldComponent() {
        }
        AbstractFormFieldComponent.propDecorators = {
            formGroup: [{ type: core.Input }],
            element: [{ type: core.Input }],
            index: [{ type: core.Input }],
            fieldType: [{ type: core.Input }],
            path: [{ type: core.Input }],
            slots: [{ type: core.Input }]
        };
        return AbstractFormFieldComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-type/abstract-type.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var /**
     * @abstract
     * @template T
     */ AbstractType = /** @class */ (function () {
        function AbstractType(options) {
            this.options = options;
        }
        Object.defineProperty(AbstractType.prototype, "asyncValidators", {
            get: /**
             * @return {?}
             */ function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractType.prototype, "validators", {
            get: /**
             * @return {?}
             */ function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractType.prototype, "updateOn", {
            get: /**
             * @return {?}
             */ function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractType.prototype, "disabled", {
            get: /**
             * @return {?}
             */ function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractType.prototype, "controlOptions", {
            get: /**
             * @return {?}
             */ function () {
                return {
                    asyncValidators: this.asyncValidators,
                    validators: this.validators,
                    updateOn: this.updateOn
                };
            },
            enumerable: true,
            configurable: true
        });
        return AbstractType;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-type/abstract-collection-type.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template TConfig, T
     */
    var /**
     * @abstract
     * @template TConfig, T
     */ AbstractCollectionType = /** @class */ (function (_super) {
        __extends(AbstractCollectionType, _super);
        // noinspection TypeScriptAbstractClassConstructorCanBeMadeProtected
        function AbstractCollectionType(childType, options) {
            var _this = _super.call(this, options) || this;
            _this.childType = childType;
            _this.fieldInstance = new _this.childType(_this.options.entrySettings);
            return _this;
        }
        return AbstractCollectionType;
    }(AbstractType));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-type/abstract-group-type.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var /**
     * @abstract
     * @template T
     */ AbstractGroupType = /** @class */ (function (_super) {
        __extends(AbstractGroupType, _super);
        function AbstractGroupType() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AbstractGroupType;
    }(AbstractType));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/init-handler.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */ InitHandler = /** @class */ (function () {
        function InitHandler(instance) {
            this.instance = instance;
            this.propIsInitialized = false;
        }
        Object.defineProperty(InitHandler.prototype, "isInitialized", {
            get: /**
             * @return {?}
             */ function () {
                return this.propIsInitialized;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @return {?}
         */
        InitHandler.prototype.setIsInitialized = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                /** @type {?} */
                var isGroupOrArray = 'controls' in this.instance;
                this.propIsInitialized = value;
                if (isGroupOrArray) {
                    (( /** @type {?} */(( /** @type {?} */(this.instance)))))._setUpControls();
                }
                this.instance.updateValueAndValidity({ onlySelf: false, emitEvent: true });
                if (isGroupOrArray) {
                    /** @type {?} */
                    var childControls_1 = (( /** @type {?} */(this.instance))).controls;
                    Object.keys(childControls_1)
                        .forEach(( /**
                 * @param {?} k
                 * @return {?}
                 */function (k) { return childControls_1[k].initHandler.setIsInitialized(value); }));
                }
            };
        return InitHandler;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/form-array.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormArray = /** @class */ (function (_super) {
        __extends(FormArray, _super);
        function FormArray() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.initHandler = new InitHandler(_this);
            return _this;
        }
        /**
         * @param {?=} opts
         * @return {?}
         */
        FormArray.prototype.updateValueAndValidity = /**
         * @param {?=} opts
         * @return {?}
         */
            function (opts) {
                if (this.initHandler && this.initHandler.isInitialized) {
                    _super.prototype.updateValueAndValidity.call(this, opts);
                }
            };
        return FormArray;
    }(ng.FormArray));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/form-control.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormControl = /** @class */ (function (_super) {
        __extends(FormControl, _super);
        function FormControl() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.initHandler = new InitHandler(_this);
            return _this;
        }
        /**
         * @param {?=} opts
         * @return {?}
         */
        FormControl.prototype.updateValueAndValidity = /**
         * @param {?=} opts
         * @return {?}
         */
            function (opts) {
                if (this.initHandler && this.initHandler.isInitialized) {
                    _super.prototype.updateValueAndValidity.call(this, opts);
                }
            };
        return FormControl;
    }(ng.FormControl));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/form-group.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormGroup = /** @class */ (function (_super) {
        __extends(FormGroup, _super);
        function FormGroup() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.initHandler = new InitHandler(_this);
            return _this;
        }
        /**
         * @param {?=} opts
         * @return {?}
         */
        FormGroup.prototype.updateValueAndValidity = /**
         * @param {?=} opts
         * @return {?}
         */
            function (opts) {
                if (this.initHandler && this.initHandler.isInitialized) {
                    _super.prototype.updateValueAndValidity.call(this, opts);
                }
            };
        return FormGroup;
    }(ng.FormGroup));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-type/abstract-layout-type.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var /**
     * @abstract
     * @template T
     */ AbstractLayoutType = /** @class */ (function (_super) {
        __extends(AbstractLayoutType, _super);
        function AbstractLayoutType() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AbstractLayoutType;
    }(AbstractGroupType));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/model-handler.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModelHandler = /** @class */ (function () {
        function ModelHandler() {
        }
        /**
         * @param {?} model
         * @param {?} builderInstance
         * @return {?}
         */
        ModelHandler.build = /**
         * @param {?} model
         * @param {?} builderInstance
         * @return {?}
         */
            function (model, builderInstance) {
                /** @type {?} */
                var group = new FormGroup({});
                this.handleModel(model, group, builderInstance);
                return group;
            };
        /**
         * @private
         * @param {?} model
         * @param {?} group
         * @param {?} builderInstance
         * @return {?}
         */
        ModelHandler.handleModel = /**
         * @private
         * @param {?} model
         * @param {?} group
         * @param {?} builderInstance
         * @return {?}
         */
            function (model, group, builderInstance) {
                var _this = this;
                Object.keys(model).forEach(( /**
                 * @param {?} name
                 * @return {?}
                 */function (name) {
                    /** @type {?} */
                    var field = model[name];
                    if (!field) {
                        return;
                    }
                    if (field instanceof AbstractLayoutType) {
                        _this.handleModel(field.options.model, group, builderInstance);
                        return;
                    }
                    /** @type {?} */
                    var control = ModelHandler.buildSingleField(field, builderInstance);
                    if (!control) {
                        return;
                    }
                    control.setParent(group);
                    if (field.disabled) {
                        control.disable();
                    }
                    group.addControl(name, control);
                    if (field.builderInstance == null && builderInstance) {
                        field.builderInstance = builderInstance;
                    }
                    field.control = control;
                }));
            };
        /**
         * @param {?} field
         * @param {?} builderInstance
         * @return {?}
         */
        ModelHandler.buildSingleField = /**
         * @param {?} field
         * @param {?} builderInstance
         * @return {?}
         */
            function (field, builderInstance) {
                /** @type {?} */
                var component;
                if (field instanceof AbstractCollectionType) {
                    component = new FormArray([], field.controlOptions);
                    ModelHandler.handleArray(field, component, builderInstance);
                }
                else if (field instanceof AbstractGroupType) {
                    component = new FormGroup({}, field.controlOptions);
                    ModelHandler.handleModel(field.options.model, component, builderInstance);
                }
                else if (field instanceof AbstractLayoutType) ;
                else if (field instanceof AbstractType) {
                    component = new FormControl({ value: null, disabled: field.disabled }, field.controlOptions);
                }
                return component;
            };
        /**
         * @private
         * @param {?} field
         * @param {?} array
         * @param {?} builderInstance
         * @return {?}
         */
        ModelHandler.handleArray = /**
         * @private
         * @param {?} field
         * @param {?} array
         * @param {?} builderInstance
         * @return {?}
         */
            function (field, array, builderInstance) {
                /** @type {?} */
                var control = ModelHandler.buildSingleField(field.fieldInstance, builderInstance);
                if (!control) {
                    return;
                }
                array.push(control);
            };
        return ModelHandler;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstract-collection/abstract-collection.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // noinspection JSUnusedGlobalSymbols
    /**
     * @abstract
     */
    var AbstractCollectionComponent = /** @class */ (function (_super) {
        __extends(AbstractCollectionComponent, _super);
        function AbstractCollectionComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        // noinspection JSUnusedGlobalSymbols
        // noinspection JSUnusedGlobalSymbols
        /**
         * @param {?} index
         * @return {?}
         */
        AbstractCollectionComponent.prototype.removeEntry =
            // noinspection JSUnusedGlobalSymbols
            /**
             * @param {?} index
             * @return {?}
             */
            function (index) {
                this.element.removeAt(index);
            };
        // noinspection JSUnusedGlobalSymbols
        // noinspection JSUnusedGlobalSymbols
        /**
         * @return {?}
         */
        AbstractCollectionComponent.prototype.addEntry =
            // noinspection JSUnusedGlobalSymbols
            /**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var newControl = ModelHandler.buildSingleField(this.fieldType.fieldInstance, this.fieldType.builderInstance);
                if (!newControl) {
                    return;
                }
                newControl.initHandler.setIsInitialized(true);
                this.element.controls.push(newControl);
            };
        AbstractCollectionComponent.propDecorators = {
            element: [{ type: core.Input }]
        };
        return AbstractCollectionComponent;
    }(AbstractFormFieldComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-slot/form-slot.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormSlotComponent = /** @class */ (function () {
        function FormSlotComponent(viewRef) {
            this.viewRef = viewRef;
        }
        FormSlotComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mw-form-slot',
                        template: ''
                    }] }
        ];
        /** @nocollapse */
        FormSlotComponent.ctorParameters = function () {
            return [
                { type: core.ViewContainerRef }
            ];
        };
        FormSlotComponent.propDecorators = {
            fieldName: [{ type: core.Input }]
        };
        return FormSlotComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-field/form-field.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormFieldComponent = /** @class */ (function (_super) {
        __extends(FormFieldComponent, _super);
        function FormFieldComponent(viewRef, cfr) {
            var _this = _super.call(this) || this;
            _this.viewRef = viewRef;
            _this.cfr = cfr;
            return _this;
        }
        // noinspection JSUnusedLocalSymbols
        // noinspection JSUnusedLocalSymbols
        /**
         * @param {?} changes
         * @return {?}
         */
        FormFieldComponent.prototype.ngOnChanges =
            // noinspection JSUnusedLocalSymbols
            /**
             * @param {?} changes
             * @return {?}
             */
            function (changes) {
                this.render();
            };
        /**
         * @return {?}
         */
        FormFieldComponent.prototype.render = /**
         * @return {?}
         */
            function () {
                if (this.fieldType == null) {
                    return;
                }
                this.viewRef.clear();
                /** @type {?} */
                var factory = this.cfr.resolveComponentFactory(this.fieldType.component);
                /** @type {?} */
                var component = this.viewRef.createComponent(factory);
                /** @type {?} */
                var isGroup = this.fieldType instanceof AbstractGroupType;
                /** @type {?} */
                var changes = {
                    formGroup: new core.SimpleChange(null, isGroup ? ( /** @type {?} */(this.element)) : this.formGroup, true),
                    element: new core.SimpleChange(null, this.element, true),
                    fieldType: new core.SimpleChange(null, this.fieldType, true),
                    slots: new core.SimpleChange(null, this.slots, true),
                    path: new core.SimpleChange(null, this.path, true),
                    index: new core.SimpleChange(null, this.index, true),
                };
                component.instance.formGroup = changes.formGroup.currentValue;
                component.instance.element = changes.element.currentValue;
                component.instance.fieldType = changes.fieldType.currentValue;
                component.instance.slots = changes.slots.currentValue;
                component.instance.path = changes.path.currentValue;
                component.instance.index = changes.index.currentValue;
                if ('ngOnChanges' in component.instance) {
                    (( /** @type {?} */(component.instance))).ngOnChanges(changes);
                }
                component.changeDetectorRef.detectChanges();
            };
        FormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mw-form-field',
                        template: ''
                    }] }
        ];
        /** @nocollapse */
        FormFieldComponent.ctorParameters = function () {
            return [
                { type: core.ViewContainerRef },
                { type: core.ComponentFactoryResolver }
            ];
        };
        return FormFieldComponent;
    }(AbstractFormFieldComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstract-form-group/abstract-form-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // noinspection JSUnusedGlobalSymbols
    /**
     * @abstract
     * @template FormType
     */
    var AbstractFormGroupComponent = /** @class */ (function (_super) {
        __extends(AbstractFormGroupComponent, _super);
        function AbstractFormGroupComponent(cfr, cdr) {
            var _this = _super.call(this) || this;
            _this.cfr = cfr;
            _this.cdr = cdr;
            _this.groupPath = '';
            _this.indexFromParent = null;
            _this.fieldPaths = {};
            _this.elements = {};
            _this.isRootGroup = false;
            _this.renderTargets = {};
            _this.initializeTimeoutHandle = null;
            return _this;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                var _this = this;
                /** @type {?} */
                var path = 'path' in changes ? changes.path.currentValue : this.path;
                if ('path' in changes) {
                    this.groupPath = (path == null || path.trim() === '')
                        ? ''
                        : path;
                }
                /** @type {?} */
                var fieldType = 'fieldType' in changes ? changes.fieldType.currentValue : this.fieldType;
                if ('path' in changes || 'fieldType' in changes) {
                    this.fieldPaths = Object.keys(fieldType.options.model).reduce(( /**
                     * @param {?} all
                     * @param {?} fieldName
                     * @return {?}
                     */function (all, fieldName) {
                        if (fieldType.options.model[fieldName] instanceof AbstractLayoutType) {
                            all[fieldName] = path;
                        }
                        else {
                            all[fieldName] = (_this.groupPath !== '' ? _this.groupPath + '.' : '') + fieldName;
                        }
                        return all;
                    }), {});
                }
                if ('index' in changes) {
                    /** @type {?} */
                    var index = changes.index.currentValue;
                    this.indexFromParent = null;
                    if (index != null) {
                        /** @type {?} */
                        var p = this.element;
                        do {
                            p = p.parent;
                            if (p instanceof FormArray) {
                                this.indexFromParent = this.index;
                                break;
                            }
                        } while (p && p.parent && !(parent instanceof FormControl));
                    }
                }
                this.elements = Object.keys(fieldType.options.model).reduce(( /**
                 * @param {?} all
                 * @param {?} fieldName
                 * @return {?}
                 */function (all, fieldName) {
                    if (fieldType.options.model[fieldName] instanceof AbstractLayoutType) {
                        all[fieldName] = _this.element;
                    }
                    else {
                        all[fieldName] = _this.element.get(fieldName);
                    }
                    return all;
                }), {});
                /** @type {?} */
                var wasRendered = false;
                if ('slots' in changes && changes.slots.currentValue) {
                    this.renderElementsInSlots();
                    wasRendered = true;
                }
                if (!wasRendered && 'mySlots' in changes && changes.mySlots.currentValue) {
                    this.renderElementsInSlots();
                }
            };
        /**
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
            function () {
                if (this.mySlots) {
                    this.renderElementsInSlots();
                    this.cdr.detectChanges();
                }
            };
        /**
         * @private
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.renderElementsInSlots = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.slots || this.mySlots) {
                    this.createRenderTargets();
                    Object.keys(this.renderTargets).map(( /**
                     * @param {?} name
                     * @return {?}
                     */function (name) {
                        if (!(name in _this.renderTargets)) {
                            return;
                        }
                        _this.renderTargets[name].viewRef.clear();
                        /** @type {?} */
                        var factory = _this.cfr.resolveComponentFactory(FormFieldComponent);
                        /** @type {?} */
                        var target = _this.renderTargets[name].viewRef.createComponent(factory);
                        target.instance.formGroup = _this.formGroup;
                        target.instance.element = _this.formGroup.get(name);
                        target.instance.slots = _this.slots;
                        target.instance.path = _this.fieldPaths[name];
                        target.instance.fieldType = _this.fieldType.options.model[name];
                        target.instance.index = _this.indexFromParent;
                        target.instance.render();
                    }));
                    if (this.isRootGroup) {
                        if (this.initializeTimeoutHandle) {
                            window.clearTimeout(this.initializeTimeoutHandle);
                        }
                        this.initializeTimeoutHandle = window.setTimeout(( /**
                         * @return {?}
                         */function () {
                            _this.element.initHandler.setIsInitialized(true);
                            _this.cdr.detectChanges();
                        }), 5);
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.createRenderTargets = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var groupPath = this.groupPath;
                if (this.slots) {
                    this.slots.toArray().forEach(( /**
                     * @param {?} slot
                     * @return {?}
                     */function (slot) {
                        if (slot.fieldName.substr(0, groupPath.length) !== groupPath) {
                            return;
                        }
                        /** @type {?} */
                        var name = slot.fieldName.substr(groupPath.length, slot.fieldName.length - groupPath.length);
                        if (name.startsWith('.')) {
                            name = name.substr(1);
                        }
                        if (name.indexOf('.') < 0 && name !== '') {
                            _this.renderTargets[name] = slot;
                        }
                    }));
                }
                if (this.mySlots) {
                    this.mySlots.toArray().forEach(( /**
                     * @param {?} slot
                     * @return {?}
                     */function (slot) {
                        _this.renderTargets[slot.fieldName] = slot;
                    }));
                }
            };
        // noinspection JSUnusedGlobalSymbols
        // noinspection JSUnusedGlobalSymbols
        /**
         * @param {?} a
         * @param {?} b
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.orderAsGiven =
            // noinspection JSUnusedGlobalSymbols
            /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                return a || b ? 1 : 0;
            };
        AbstractFormGroupComponent.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AbstractFormGroupComponent.ctorParameters = function () {
            return [
                { type: core.ComponentFactoryResolver },
                { type: core.ChangeDetectorRef }
            ];
        };
        AbstractFormGroupComponent.propDecorators = {
            element: [{ type: core.Input }],
            isRootGroup: [{ type: core.Input }],
            mySlots: [{ type: core.ContentChildren, args: [FormSlotComponent, { descendants: true },] }]
        };
        return AbstractFormGroupComponent;
    }(AbstractFormFieldComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstract-layout/abstract-layout.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // noinspection JSUnusedGlobalSymbols
    /**
     * @abstract
     * @template FormType
     */
    var  
    // noinspection JSUnusedGlobalSymbols
    /**
     * @abstract
     * @template FormType
     */
    AbstractLayoutComponent = /** @class */ (function (_super) {
        __extends(AbstractLayoutComponent, _super);
        function AbstractLayoutComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AbstractLayoutComponent;
    }(AbstractFormGroupComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-group/form-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormGroupType = /** @class */ (function (_super) {
        __extends(FormGroupType, _super);
        function FormGroupType() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.component = FormGroupComponent;
            return _this;
        }
        return FormGroupType;
    }(AbstractGroupType));
    var FormGroupComponent = /** @class */ (function (_super) {
        __extends(FormGroupComponent, _super);
        function FormGroupComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FormGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mw-form-group',
                        template: "\n    <ng-content></ng-content>\n    <ng-container *ngFor=\"let field of fieldType.options.model | keyvalue:orderAsGiven\">\n      <mw-form-field *ngIf=\"renderTargets[field.key] == null\"\n                     [formGroup]=\"element\"\n                     [element]=\"elements[field.key]\"\n                     [fieldType]=\"field.value\"\n                     [path]=\"fieldPaths[field.key]\"\n                     [index]=\"indexFromParent\"\n                     [slots]=\"slots\">\n      </mw-form-field>\n    </ng-container>\n  "
                    }] }
        ];
        return FormGroupComponent;
    }(AbstractFormGroupComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-builder/form-builder.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var FormBuilderComponent = /** @class */ (function () {
        function FormBuilderComponent() {
            this.onSubmit = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        FormBuilderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.group == null) {
                    this.rebuildForm();
                }
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        FormBuilderComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if ('formModel' in changes && changes.formModel.currentValue) {
                    this.rebuildForm();
                    this.fieldType = new FormGroupType({
                        model: this.formModel,
                    });
                    Object.assign(this.fieldType, {
                        builderInstance: this,
                        component: FormGroupComponent,
                        control: this.group,
                    });
                }
                if ('formData' in changes && changes.formData.currentValue) {
                    if (!('formModel' in changes)) {
                        this.initializeCollectionFields(this.group, this.formModel, this.formData);
                        this.group.initHandler.setIsInitialized(false);
                        this.group.initHandler.setIsInitialized(true);
                    }
                    if (this.group) {
                        this.group.patchValue(this.formData);
                    }
                }
            };
        /**
         * @return {?}
         */
        FormBuilderComponent.prototype.rebuildForm = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var res = null;
                /** @type {?} */
                var groupIsInitialized = false;
                if (this.group) {
                    res = Object.assign({}, this.group.value);
                    groupIsInitialized = this.group.initHandler.isInitialized;
                }
                else if (this.formData) {
                    res = Object.assign({}, this.formData);
                }
                this.group = ModelHandler.build(this.formModel, this);
                this.initializeCollectionFields(this.group, this.formModel, res);
                if (this.group && res) {
                    if (groupIsInitialized) {
                        this.group.initHandler.setIsInitialized(true);
                    }
                    this.group.patchValue(res);
                }
            };
        /**
         * @private
         * @param {?} group
         * @param {?} model
         * @param {?} data
         * @return {?}
         */
        FormBuilderComponent.prototype.initializeCollectionFields = /**
         * @private
         * @param {?} group
         * @param {?} model
         * @param {?} data
         * @return {?}
         */
            function (group, model, data) {
                var _this = this;
                Object.keys(model).forEach(( /**
                 * @param {?} name
                 * @return {?}
                 */function (name) {
                    /** @type {?} */
                    var formType = model[name];
                    /** @type {?} */
                    var childData = (data && name in data) ? data[name] : null;
                    /** @type {?} */
                    var control = group.get(name);
                    if (formType instanceof AbstractGroupType && control instanceof FormGroup) {
                        _this.initializeCollectionFields(control, formType.options.model, childData);
                    }
                    else if (formType instanceof AbstractLayoutType) {
                        _this.initializeCollectionFields(group, formType.options.model, data);
                    }
                    else if (formType instanceof AbstractCollectionType && control instanceof FormArray) {
                        _this.initializeCollectionField(formType, control, childData);
                    }
                }));
            };
        /**
         * @private
         * @param {?} collection
         * @param {?} array
         * @param {?=} data
         * @return {?}
         */
        FormBuilderComponent.prototype.initializeCollectionField = /**
         * @private
         * @param {?} collection
         * @param {?} array
         * @param {?=} data
         * @return {?}
         */
            function (collection, array, data) {
                /** @type {?} */
                var numberOfEntries = Array.isArray(data) ? data.length : 0;
                array.controls.splice(0, array.controls.length);
                if (numberOfEntries === 0) {
                    return;
                }
                /** @type {?} */
                var fieldInstance = collection.fieldInstance;
                for (var i = 0; i < numberOfEntries; i++) {
                    /** @type {?} */
                    var control = ModelHandler.buildSingleField(fieldInstance, this);
                    if (!control) {
                        continue;
                    }
                    if (fieldInstance instanceof AbstractGroupType && control instanceof FormGroup) {
                        control.setParent(array);
                        if (fieldInstance.disabled) {
                            control.disable();
                        }
                        this.initializeCollectionFields(control, fieldInstance.options.model, data[i]);
                    }
                    else if (fieldInstance instanceof AbstractCollectionType && control instanceof FormArray) {
                        control.setParent(array);
                        if (fieldInstance.disabled) {
                            control.disable();
                        }
                        this.initializeCollectionField(fieldInstance, control, data[i]);
                    }
                    array.controls.push(control);
                }
            };
        /**
         * @return {?}
         */
        FormBuilderComponent.prototype.submit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                Object.keys(this.group.controls).forEach(( /**
                 * @param {?} field
                 * @return {?}
                 */function (field) {
                    /** @type {?} */
                    var control = _this.group.get(field);
                    control.markAsDirty();
                    control.updateValueAndValidity();
                }));
                if (!this.group.valid) {
                    return;
                }
                this.onSubmit.emit(this.group.value);
                return this.group.value;
            };
        /**
         * @param {?=} group
         * @return {?}
         */
        FormBuilderComponent.prototype.getErrors = /**
         * @param {?=} group
         * @return {?}
         */
            function (group) {
                var _this = this;
                /** @type {?} */
                var errors = group instanceof FormArray ? [] : {};
                if (group == null) {
                    group = this.group;
                }
                /** @type {?} */
                var idx = 0;
                Object.keys(group.controls).forEach(( /**
                 * @param {?} name
                 * @return {?}
                 */function (name) {
                    idx++;
                    /** @type {?} */
                    var control = group.get(name);
                    if (control instanceof FormArray || control instanceof FormGroup) {
                        /** @type {?} */
                        var tmpErrors = _this.getErrors(control);
                        if (tmpErrors) {
                            errors[name] = tmpErrors;
                        }
                    }
                    else if (control instanceof FormControl) {
                        if (control.errors == null) {
                            return null;
                        }
                        if (group instanceof FormArray) {
                            (( /** @type {?} */(errors)))[idx] = control.errors;
                        }
                        else {
                            errors[name] = control.errors;
                        }
                    }
                }));
                return (group instanceof FormGroup && Object.keys(errors).length === 0)
                    || Array.isArray(errors) && errors.length === 0 ? null : errors;
            };
        FormBuilderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mw-form-builder',
                        template: "\n    <ng-content></ng-content>\n    <form [formGroup]=\"group\" (ngSubmit)=\"submit()\">\n      <mw-form-group [element]=\"group\"\n                     [formGroup]=\"group\"\n                     [fieldType]=\"fieldType\"\n                     [slots]=\"slots\"\n                     [isRootGroup]=\"true\">\n      </mw-form-group>\n    </form>\n  "
                    }] }
        ];
        FormBuilderComponent.propDecorators = {
            formModel: [{ type: core.Input }],
            formData: [{ type: core.Input }],
            onSubmit: [{ type: core.Output }],
            slots: [{ type: core.ContentChildren, args: [FormSlotComponent, { descendants: true },] }]
        };
        return FormBuilderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-builder.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormBuilderModule = /** @class */ (function () {
        function FormBuilderModule() {
        }
        FormBuilderModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            FormBuilderComponent,
                            FormGroupComponent,
                            FormFieldComponent,
                            FormSlotComponent,
                        ],
                        entryComponents: [
                            FormFieldComponent,
                            FormGroupComponent,
                        ],
                        imports: [
                            ng.ReactiveFormsModule,
                            common.CommonModule,
                        ],
                        exports: [
                            FormBuilderComponent,
                            FormGroupComponent,
                            FormFieldComponent,
                            FormSlotComponent,
                        ],
                    },] }
        ];
        return FormBuilderModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: mw-form-builder.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AbstractCollectionComponent = AbstractCollectionComponent;
    exports.AbstractFormFieldComponent = AbstractFormFieldComponent;
    exports.AbstractFormGroupComponent = AbstractFormGroupComponent;
    exports.AbstractLayoutComponent = AbstractLayoutComponent;
    exports.FormBuilderComponent = FormBuilderComponent;
    exports.FormFieldComponent = FormFieldComponent;
    exports.FormSlotComponent = FormSlotComponent;
    exports.FormBuilderModule = FormBuilderModule;
    exports.AbstractGroupType = AbstractGroupType;
    exports.AbstractCollectionType = AbstractCollectionType;
    exports.AbstractLayoutType = AbstractLayoutType;
    exports.AbstractType = AbstractType;
    exports.ɵa = FormGroupComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=mw-form-builder.umd.js.map